fgl-5.8.3.0: Martin Erwig's Functional Graph Library

Safe Haskell | Safe-Inferred
Language | Haskell98

Data.Graph.Inductive.Monad.STArray

Contents

- Graph Representation
- Utilities

Description

Static IOArray-based Graphs

Synopsis

- newtype SGr s a b = SGr (GraphRep s a b)
- type GraphRep s a b = (Int, Array Node (Context' a b), STArray s Node Bool)
- type Context' a b = Maybe (Adj b, a, Adj b)
- type USGr s = SGr s () ()
- defaultGraphSize :: Int
- emptyN :: Int -> ST s (SGr s a b)
- removeDel :: STArray s Node Bool -> Adj b -> ST s (Adj b)

# Graph Representation

newtype SGr s a b Source #

Constructors

SGr (GraphRep s a b) |

#### Instances

Instances details

GraphM (ST s) (SGr s) Source # |

Instance details

Defined in Data.Graph.Inductive.Monad.STArray

Methods

emptyM :: ST s (SGr s a b) Source #

isEmptyM :: ST s (SGr s a b) -> ST s Bool Source #

matchM :: Node -> ST s (SGr s a b) -> ST s (Decomp (SGr s) a b) Source #

mkGraphM :: [LNode a] -> [LEdge b] -> ST s (SGr s a b) Source #

labNodesM :: ST s (SGr s a b) -> ST s [LNode a] Source #

matchAnyM :: ST s (SGr s a b) -> ST s (GDecomp (SGr s) a b) Source #

noNodesM :: ST s (SGr s a b) -> ST s Int Source #

nodeRangeM :: ST s (SGr s a b) -> ST s (Node, Node) Source #

labEdgesM :: ST s (SGr s a b) -> ST s [LEdge b] Source #

(Show a, Show b) => Show (SGr RealWorld a b) Source # | Please not that this instance is unsafe.
Instance details Defined in Data.Graph.Inductive.Monad.STArray Methods showsPrec :: Int -> SGr RealWorld a b -> ShowS Source # show :: SGr RealWorld a b -> String Source # showList :: [SGr RealWorld a b] -> ShowS Source #

type GraphRep s a b = (Int, Array Node (Context' a b), STArray s Node Bool) Source #

type Context' a b = Maybe (Adj b, a, Adj b) Source #

type USGr s = SGr s () () Source #

defaultGraphSize :: Int Source #

emptyN :: Int -> ST s (SGr s a b) Source #

# Utilities

removeDel :: STArray s Node Bool -> Adj b -> ST s (Adj b) Source #

filter list (of successors/predecessors) through a boolean ST array representing deleted marks